#include <pro_ext.h>


#define BADHANDLE  0    // Not a handle.
#define ulong  unsigned long
#define uchar  unsigned char

struct rand_struct {
  unsigned long seed1,seed2,max_value;
  double max_value_dbl;
};

double rnd(struct rand_struct *rand_st)
{
  rand_st->seed1=(rand_st->seed1*3+rand_st->seed2) % rand_st->max_value;
  rand_st->seed2=(rand_st->seed1+rand_st->seed2+33) % rand_st->max_value;
  return (((double) rand_st->seed1)/rand_st->max_value_dbl);
}

void randominit(struct rand_struct *rand_st,ulong seed1, ulong seed2)
{
  rand_st->max_value= 0x3FFFFFFFL;
  rand_st->max_value_dbl=(double) rand_st->max_value;
  rand_st->seed1=seed1%rand_st->max_value ;
  rand_st->seed2=seed2%rand_st->max_value;
}

void hash_password(ulong *result, const char *password)
{
  register ulong nr=1345345333L, add=7, nr2=0x12345671L;
  ulong tmp;
  for (; *password ; password++)
  {
    if (*password == ' ' || *password == '\t')
      continue;     /* skipp space in password */
    tmp= (ulong) (uchar) *password;
    nr^= (((nr & 63)+add)*tmp)+ (nr << 8);
    nr2+=(nr2 << 8) ^ nr;
    add+=tmp;
  }
  result[0]=nr & (((ulong) 1L << 31) -1L); /* Don't use sign bit (str2int) */;
  result[1]=nr2 & (((ulong) 1L << 31) -1L);
  return;
}

char *scramble(char *to,const char *message,const char *password)
{
  struct rand_struct rand_st;
  ulong hash_pass[2],hash_message[2];
  if (password && password[0])
  {
    char *to_start=to;
    hash_password(hash_pass,password);
    hash_password(hash_message,message);
    randominit(&rand_st,hash_pass[0] ^ hash_message[0],
     hash_pass[1] ^ hash_message[1]);
    while (*message++)
      *to++= (char) (floor(rnd(&rand_st)*31)+64);
    {           /* Make it harder to break */
      char extra=(char) (floor(rnd(&rand_st)*31));
      while (to_start != to) *(to_start++)^=extra;
    }
  }
  *to=0;
  return to;
}


/*---------------------------------------------------------*/
FAR password(ParamBlk FAR *pblk)
{
 MHANDLE     meshand,passhand;
 int         meslen,passlen;
 static char FAR outstr[255]="ABCDEFGH";
 char *mes, *pass, i;
 char ss[255], p[255], m[255];

  meshand = pblk->p[0].val.ev_handle;         // The object
  meslen = pblk->p[0].val.ev_length;
  passhand = pblk->p[1].val.ev_handle;         // The object
  passlen = pblk->p[1].val.ev_length;

   if ((meshand != BADHANDLE) && (meslen > 0) &&
   (passhand != BADHANDLE) && (passlen > 0))
   {
   mes=(char *)_HandToPtr(meshand);
   pass=(char *)_HandToPtr(passhand);

   for (i=0;i<meslen;i++)
   m[i]=*(mes+i);
   for (i=0;i<passlen;i++)
   p[i]=*(pass+i);

   scramble(ss,m,p);

   for (i=0;i<9;i++)
   outstr[i]=*(ss+i);
   outstr[9]=0;
   }
_RetChar(outstr);
};


FoxInfo myFoxInfo[] = {
    {"PASSWORD",password,2,"C,C"}
};

FoxTable _FoxTable = {
    (FoxTable FAR *) 0,
    sizeof( myFoxInfo) / sizeof( FoxInfo ),
    myFoxInfo
};
